var countProblems=0;
var linkCounts=null;
var wpStringBundle=null;

function onLoad()
{
	wpStringBundle = document.getElementById("wikipediastrings");
	var params = window.arguments[1];
	var text=params[0];
	listTemplates(text);
	listLinks(text);
	checkProblems(text);
	articleStats(text);
}

function onAccept()
{
	return true;
}

function listItems(text, parentId, open, close) {
	var linkTree=document.getElementById(parentId);
	linkCounts=new Array();
	var start=text.indexOf(open);
	var end=text.indexOf(close,start);
	while ((start>=0) && (end>=0)) {
		var end=text.indexOf(close,start);
		if (end>0) {
			var link=text.substring(start+2,end);
			if (link.indexOf("|")>0) {
				link=link.substring(0,link.indexOf("|"));
			}
			link=trim(link);
			var count=1;
			var found=false;
			for (var i=0;i<linkCounts.length;i++) {
				var linkCount=linkCounts[i];
				if (linkCount[0]==link) {
					count=linkCount[1]+1;
					linkCounts[i] = new Array(link,count);
					found=true;
					break;
				}
			}
			if (!found) {
				linkCount=new Array(link,count);
				linkCounts.push(linkCount);
			}
		}
		// search next
		var start=text.indexOf(open, end);
	}
	//output links
	linkCounts.sort();
	var count=0;
	for (var i=0;i<linkCounts.length;i++) {
		linkCount=linkCounts[i];
		var item=document.createElement('treeitem');
		var row=document.createElement('treerow');
		var cell=document.createElement('treecell');
		cell.setAttribute("label",linkCount[0]);
		row.appendChild(cell);
		cell=document.createElement('treecell');
		cell.setAttribute("label",linkCount[1]);
		count=count+linkCount[1];
		row.appendChild(cell);
		item.appendChild(row);
		linkTree.appendChild(item);
	}
	return count;
}

function listLinks(text) {
	document.getElementById("statistics-links").setAttribute("value",listItems(text, "items-links", "[[", "]]"));
}

function listTemplates(text) {
	document.getElementById("statistics-templates").setAttribute("value",listItems(text, "items-templates", "{{", "}}"));
}

function countWords(text) {
	var start=text.indexOf("<");
	while (start>=0) {
		var end=text.indexOf(">",start);
		text=text.substring(0,start-1)+text.substring(end+1,text.length);
		start=text.indexOf("<");
	}
//	alert(text);
	var count=0;
	var lastAlNum=false;
	for (var i=0;i<text.length;i++) {
		var c=text.charAt(i);
		var alNum=(('a'<=c) && (c<='z'))
			||(('A'<=c) && (c<='Z'))
			||(('0'<=c) && (c<='9'))
			||('äöüß'.indexOf(c)>=0);
		if (alNum && !lastAlNum) {
			count++;
		}
		lastAlNum=alNum;
	}
	document.getElementById("statistics-words").setAttribute("value","~"+count);
}

function articleStats(text) {
	document.getElementById("statistics-bytes").setAttribute("value",text.length);
	countWords(text);
}

function numberOf(text,sub) {
	var count=0;
	var pos=text.indexOf(sub);
	while (pos>=0) {
		count++;
		pos=text.indexOf(sub,pos+1);
	}
	return count;
}

function addProblem(text) {
	var problems=document.getElementById("items-problems");
	var item=document.createElement('treeitem');
	var row=document.createElement('treerow');
	var cell=document.createElement('treecell');
	cell.setAttribute("label",text);
	row.appendChild(cell);
	item.appendChild(row);
	problems.appendChild(item);
	countProblems++;
}

function checkEqual(text,open,close) {
	if (numberOf(text,open)!=numberOf(text,close)) {
		addProblem(formatString(wpStringBundle.getString("wikipedia.checks.openclose"),new Array(open,close)));
	}
}

function checkHeaders(text) {
	var parts=text.split("\n");
	for (var i=0;i<parts.length;i++) {
		var part=trim(parts[i]);
		if (part.indexOf("=")==0) {
			var start=0;
			while (part.charAt(start)=='=') {
				start++;
			}
			var end=0;
			while (part.charAt(part.length-end-1)=='=') {
				end++;
			}
			if (start!=end) {
				addProblem(formatString(wpStringBundle.getString("wikipedia.checks.headerformat"),new Array(part)));
			}
		}
	}
}

function checkProblems(text) {
	var countProblems=0;
	var wbPrefs = getPreferences();
	if (wbPrefs.getBoolPref("checks.openclose")) {
		checkEqual(text,"[","]");
		checkEqual(text,"{","}");
		checkEqual(text,"(",")");
	}
	if (wbPrefs.getBoolPref("checks.headers")) {
		checkHeaders(text);
	}
	if (wbPrefs.getBoolPref("checks.multiplelink")) {
		for (var i=0;i<linkCounts.length;i++) {
			var linkCount=linkCounts[i];
			if (linkCount[1]>1) {
				addProblem(formatString(wpStringBundle.getString("wikipedia.checks.multiplelinks"),new Array(linkCount[0])));
			}
		}
	}
	if (countProblems==0) {
		addProblem(wpStringBundle.getString("wikipedia.checks.noproblems"));
	}
}