var currentRow=null;
var currentColumn=0;
var wikipedia=null;

function addCharacter(character, shownLabel) {
	var row=currentRow;
	if ((currentRow==null) || (currentColumn==10)) {
		var rows = document.getElementById("character_rows");
		row=document.createElement('row');
		rows.appendChild(row);
		currentColumn=0;
		currentRow=row;
	}
	var label=document.createElement('label');
	label.setAttribute('value',shownLabel);
	label.setAttribute('onclick',"select('"+character+"')");
	row.appendChild(label);
	currentColumn++;
}

function loadCharacterCollection(id) {
	currentRow=null;
	currentColumn=0;
	var rows = document.getElementById("character_rows");
	while (rows.firstChild!=null) {
		rows.removeChild(rows.firstChild);
	}
	var nodelist = getNodes("chrome://wikipedia/content/special_characters.xml","/characters/characterCollection[attribute::id='"+id+"']/character");
	for(var i=0; i < nodelist.length; i++) {
		var node=nodelist[i];
		var character = node.getAttribute('value');
		var label = node.getAttribute('label');
		if (label==null) {
			label=character;
		}
		addCharacter(character, label);
	}
	getPreferences().setCharPref('specialchars.collection',id);
//	document.getElementById('wikipedia-special').sizeToContent();
}

function loadCharacterCollections() {
	var lastCollection=getPreferences().getCharPref('specialchars.collection');
	var nodelist = getNodes("chrome://wikipedia/content/special_characters.xml","/characters/characterCollection");
	for(var i=0; i < nodelist.length; i++) {
		var node=nodelist[i];
		var id = node.getAttribute('id');
		var label = node.getAttribute('label');
		var languages=document.getElementById('special-languages');
		var item=document.createElement('menuitem');
		item.setAttribute('label',label);
		item.setAttribute('value',id);
		item.setAttribute('oncommand',"loadCharacterCollection('"+id+"')");
		if ((lastCollection=='' && i==0) || (lastCollection==id)) {
			loadCharacterCollection(id);
			item.setAttribute('selected','true');
		}
		languages.appendChild(item);
	}
}

function onLoad()
{
	var params = window.arguments[1];
	wikipedia = params[1];
	loadCharacterCollections();
}

function select(character) {
	wikipedia.insert(character);
}

function onCancel()
{
	var ok = window.arguments[0]; 
	ok[0] = false;
	return true;
}

function charSelected(event)
{
	alert("Click");
	alert(event.target.tagName);
	return true;
}